
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>（转）ROS导航之参数配置和自适应蒙特卡罗定位 / 憋错料</title>

    <meta name="description" content="（转）ROS导航之参数配置和自适应蒙特卡罗定位 我们的机器人使用两种导航算法在地图中移动:全局导航(global)和局部导航(local).这些导航算法通过代价地图来处理地图中的各种信息,导航stack使用两种costmaps http://www.cnblogs.com/zjiaxing/p/5543386.html存储环境的障碍信息.一个costmap进行全局规划,在整个环境做长期的规划,而另一个是用于局部规划和避障. 全局导航: 在已建立的地图上做一个远距离目标的路径规划. 局部导航: 在正在建立的地图上做近距离目标同时要实时避开障碍物">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">（转）ROS导航之参数配置和自适应蒙特卡罗定位</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>我们的机器人使用两种导航算法在地图中移动：全局导航（global）和局部导航（local)。这些导航算法通过代价地图来处理地图中的各种信息，导航stack使用两种costmaps&nbsp;<a href="http://www.cnblogs.com/zjiaxing/p/5543386.html" rel="external nofollow noreferrer">http://www.cnblogs.com/zjiaxing/p/5543386.html</a>存储环境的障碍信息。一个costmap进行全局规划，在整个环境做长期的规划，而另一个是用于局部规划和避障。</p>
<p><strong>全局导航：</strong></p>
<p>在已建立的地图上做一个远距离目标的路径规划。</p>
<p><strong>局部导航：</strong></p>
<p>在正在建立的地图上做近距离目标同时要实时避开障碍物的路径规划。</p>
<p><strong>代价地图的参数用于配置算法的计算行为。下面进行分析：</strong></p>
<p><strong>基本参数的的配置：</strong></p>
<p>在你的launch（launch文件编写<a href="http://www.cnblogs.com/zjiaxing/p/5542614.html" rel="external nofollow noreferrer">http://www.cnblogs.com/zjiaxing/p/5542614.html</a>）里，首先创建一个costmap_common_params.yaml文件，内容：</p>
<p><img src="/img/fz.gif"></p>
<pre>obstacle_range: 2.5raytrace_range: 3.0
footprint: [[x0, y0], [x1, y1], ... [xn, yn]]
#robot_radius: ir_of_robot
inflation_radius: 0.55

observation_sources: laser_scan_sensor point_cloud_sensor

laser_scan_sensor: {sensor_frame: frame_name, data_type: LaserScan, topic: topic_name, marking: true, clearing: true}

point_cloud_sensor: {sensor_frame: frame_name, data_type: PointCloud, topic: topic_name, marking: true, clearing: true}</pre>
<p><img src="/img/fz.gif"></p>
<p>这个文件主要用于配置基本的参数，这些参数会被用于local_costmap和global_costmap.</p>
<p><strong>obstacle_range 和raytrace_range：</strong>表示传感器的最大探测距离，并在代价地图中引入探测障碍物信息。obstacle_range用于障碍物探测，例如机器人检测到一个距离小于2.5m的障碍物，就会将这个障碍物引入到代价地图中 raytrace_range用于机器人运动过程中，实时清除代价地图中的障碍物，例如该机器人将清除前面距离3m（传感器获取的数据）的障碍物。并更新可移动的自由空间数据。其实我们用激光传感器是无法感知物体的形状和大小的，但是，这个测量结果足够定位的了。</p>
<p><strong>footprint：</strong>将机器人的几何参数告诉导航功能包集。这样，机器人和障碍物之间保持一个合理的距离，也就是说，例如前方有个门，要提前探知机器人是否能穿过这个门。</p>
<p><strong>inflation_radius：</strong>给定机器人与障碍物之间必须要保持的最小距离。按照机器人的内切半径对障碍物进行膨胀处理。</p>
<p><strong>observation_sources:</strong>设定导航包所使用的传感器。</p>
<p><strong>laser_scan_sensor和point_cloud_sensor:</strong>对传感器的坐标系和数据进行配置。这个也会用于代价地图添加和清除障碍物。例如，你可以用激光雷达传感器用于在代价地图添加障碍物，再添加kinect用于导航和清除障碍物。</p>
<p><strong>全局代价地图的配置：</strong></p>
<p>创建一个global_costmap_params.yaml文件，内容：</p>
<pre>global_costmap:
global_frame: /map
robot_base_frame: base_link
update_frequency: 5.0
static_map: true</pre>
<p><strong>global_costmap和robot_base_frame</strong>：定义机器人和地图之间的坐标变换，建立全局代价地图必须使用这个变换。</p>
<p><strong>update_frequency:</strong>地图更新的频率。</p>
<p><strong>static_map:</strong>&nbsp;是否使用一个地图或者地图服务器来初始化全局代价地图，如果不使用静态地图，这个参数为false.</p>
<p><strong>局部代价地图的配置：</strong></p>
<p>创建一个local_costmap_params.yaml 文件，内容：</p>
<p><img src="/img/fz.gif"></p>
<pre>local_costmap:
global_frame: odom
robot_base_frame: base_link
update_frequency: 5.0
publish_frequency: 2.0
static_map: false
rolling_window: true
width: 6.0
height: 6.0
resolution: 0.05</pre>
<p><img src="/img/fz.gif"></p>
<p><strong>publish_frequency:</strong>发布信息的频率，也就是costmap可视化信息发布的频率。</p>
<p><strong>rolling_window:</strong>在机器人运动过程中，代价地图始终以机器人为中心，这个在源码里是个if函数。</p>
<p><strong>width、height、resolution:</strong>代价地图的的尺寸和分辨率，单位都是m.一般情况下resolution的数值与建的static map的一致。</p>
<p><strong>基本局部规划器配置：</strong></p>
<p>创建base_local_planner_params.yaml 文件，内容：</p>
<p><img src="/img/fz.gif"></p>
<pre>TrajectoryPlannerROS:
max_vel_x: 0.45
min_vel_x: 0.1
max_vel_theta: 1.0
min_in_place_vel_theta: 0.4

acc_lim_theta: 3.2
acc_lim_x: 2.5
acc_lim_y: 2.5

holonomic_robot: false</pre>
<p><img src="/img/fz.gif"></p>
<p>这个配置文件设定了机器人的最大和最小速度限制值，也设定了加速度的限值。</p>
<p><strong>holonomic_robot:</strong>&nbsp;如果你的机器人是全向移动机器人那么此值为true，笔者的为差分型的。</p>
<p>为了运行导航功能包集，还需要创建个启动文件 move_base.launch ，内容：</p>
<p><img src="/img/fz.gif"></p>
<pre>&lt;launch&gt;
&lt;master auto="start"/&gt;

&lt;!-- Run the map server --&gt;
&lt;node name="map_server" pkg="map_server" type="map_server" args="$(find your_map_package)/your_map.pgm your_map_resolution.yaml"/&gt;

&lt;!--- Run AMCL --&gt;
&lt;include file="$(find amcl)/examples/amcl_diff.launch.launch" /&gt;
&lt;node pkg="move_base" type="move_base" respawn="false" name="move_base" output="screen"&gt;
&lt;rosparam file="$(find your_nav_package)/launch/costmap_common_params.yaml" command="load" ns="global_costmap" /&gt;
&lt;rosparam file="$(find your_nav_package)/launch/costmap_common_params.yaml" command="load" ns="local_costmap" /&gt;
&lt;rosparam file="$(find your_nav_package)/launch/local_costmap_params.yaml" command="load" /&gt;
&lt;rosparam file="$(find your_nav_package)/launch/global_costmap_params.yaml" command="load" /&gt;
&lt;rosparam file="$(find your_nav_package)/launch/base_local_planner_params.yaml" command="load" /&gt;
&lt;/node&gt;
&lt;/launch&gt;</pre>
<p><img src="/img/fz.gif"></p>
<p>利用自适应蒙特卡罗定位（AMCL）算法完成机器人定位，此方法是一种在2D环境下移动机器人的概率统计方法，这种方法在ROS系统中的具体实现是通过在已知地图的基础上使用粒子滤波算法跟踪机器人的位姿。如果你在rviz里不通过2D Pose Estimate 按钮设定初始位姿，则AMCL会假定你的机器人从坐标原点开始运行。这个包默认激光雷达数据，你也可以修改源码，适应如双目之类的传感器。amcl_diff.launch.launch是专用于支持差分驱动机器人平台的&nbsp;<a href="https://github.com/ros-planning/navigation/tree/indigo-devel/amcl" rel="external nofollow noreferrer">https://github.com/ros-planning/navigation/tree/indigo-devel/amcl</a>&nbsp;内容如下：</p>
<p><img src="/img/fz.gif"></p>
<pre>&lt;launch&gt;
&lt;node pkg="amcl" type="amcl" name="amcl" output="screen"&gt;
&lt;!-- Publish scans from best pose at a max of 10 Hz --&gt;
&lt;param name="odom_model_type" value="diff"/&gt;
&lt;param name="odom_alpha5" value="0.1"/&gt;
&lt;param name="transform_tolerance" value="0.2" /&gt;
&lt;param name="gui_publish_rate" value="10.0"/&gt;
&lt;param name="laser_max_beams" value="30"/&gt;
&lt;param name="min_particles" value="500"/&gt;
&lt;param name="max_particles" value="5000"/&gt;
&lt;param name="kld_err" value="0.05"/&gt;
&lt;param name="kld_z" value="0.99"/&gt;
&lt;param name="odom_alpha1" value="0.2"/&gt;
&lt;param name="odom_alpha2" value="0.2"/&gt;
&lt;!-- translation std dev, m --&gt;
&lt;param name="odom_alpha3" value="0.8"/&gt;
&lt;param name="odom_alpha4" value="0.2"/&gt;
&lt;param name="laser_z_hit" value="0.5"/&gt;
&lt;param name="laser_z_short" value="0.05"/&gt;
&lt;param name="laser_z_max" value="0.05"/&gt;
&lt;param name="laser_z_rand" value="0.5"/&gt;
&lt;param name="laser_sigma_hit" value="0.2"/&gt;
&lt;param name="laser_lambda_short" value="0.1"/&gt;
&lt;param name="laser_lambda_short" value="0.1"/&gt;
&lt;param name="laser_model_type" value="likelihood_field"/&gt;
&lt;!-- &lt;param name="laser_model_type" value="beam"/&gt; --&gt;
&lt;param name="laser_likelihood_max_dist" value="2.0"/&gt;
&lt;param name="update_min_d" value="0.2"/&gt;
&lt;param name="update_min_a" value="0.5"/&gt;
&lt;param name="odom_frame_id" value="odom"/&gt;
&lt;param name="resample_interval" value="1"/&gt;
&lt;param name="transform_tolerance" value="0.1"/&gt;
&lt;param name="recovery_alpha_slow" value="0.0"/&gt;
&lt;param name="recovery_alpha_fast" value="0.0"/&gt;
&lt;/node&gt;
&lt;/launch&gt;</pre>
<p><img src="/img/fz.gif"></p>
<p><strong>min_particles和max_particles：</strong>设定算法运行所允许的粒子的最小和最大数量，如果粒子数多，就算会更加精确，当然也后悔更加消耗cpu资源。</p>
<p><strong>laser_model_type：</strong>配置激光雷达类型。也可以设置beam光束雷达。</p>
<p><strong>laser_likelihood_max_dist：</strong>设置地图中障碍物膨胀的最大距离。</p>
<p>转自<a href="http://www.cnblogs.com/zjiaxing/p/5559382.html" rel="external nofollow noreferrer">http://www.cnblogs.com/zjiaxing/p/5559382.html</a></p>
<p>我们的机器人使用两种导航算法在地图中移动：全局导航（global）和局部导航（local)。这些导航算法通过代价地图来处理地图中的各种信息，导航stack使用两种costmaps&nbsp;<a href="http://www.cnblogs.com/zjiaxing/p/5543386.html" rel="external nofollow noreferrer">http://www.cnblogs.com/zjiaxing/p/5543386.html</a>存储环境的障碍信息。一个costmap进行全局规划，在整个环境做长期的规划，而另一个是用于局部规划和避障。</p>
<p><strong>全局导航：</strong></p>
<p>在已建立的地图上做一个远距离目标的路径规划。</p>
<p><strong>局部导航：</strong></p>
<p>在正在建立的地图上做近距离目标同时要实时避开障碍物的路径规划。</p>
<p><strong>代价地图的参数用于配置算法的计算行为。下面进行分析：</strong></p>
<p><strong>基本参数的的配置：</strong></p>
<p>在你的launch（launch文件编写<a href="http://www.cnblogs.com/zjiaxing/p/5542614.html" rel="external nofollow noreferrer">http://www.cnblogs.com/zjiaxing/p/5542614.html</a>）里，首先创建一个costmap_common_params.yaml文件，内容：</p>
<p><img src="/img/fz.gif"></p>
<pre>obstacle_range: 2.5raytrace_range: 3.0
footprint: [[x0, y0], [x1, y1], ... [xn, yn]]
#robot_radius: ir_of_robot
inflation_radius: 0.55

observation_sources: laser_scan_sensor point_cloud_sensor

laser_scan_sensor: {sensor_frame: frame_name, data_type: LaserScan, topic: topic_name, marking: true, clearing: true}

point_cloud_sensor: {sensor_frame: frame_name, data_type: PointCloud, topic: topic_name, marking: true, clearing: true}</pre>
<p><img src="/img/fz.gif"></p>
<p>这个文件主要用于配置基本的参数，这些参数会被用于local_costmap和global_costmap.</p>
<p><strong>obstacle_range 和raytrace_range：</strong>表示传感器的最大探测距离，并在代价地图中引入探测障碍物信息。obstacle_range用于障碍物探测，例如机器人检测到一个距离小于2.5m的障碍物，就会将这个障碍物引入到代价地图中 raytrace_range用于机器人运动过程中，实时清除代价地图中的障碍物，例如该机器人将清除前面距离3m（传感器获取的数据）的障碍物。并更新可移动的自由空间数据。其实我们用激光传感器是无法感知物体的形状和大小的，但是，这个测量结果足够定位的了。</p>
<p><strong>footprint：</strong>将机器人的几何参数告诉导航功能包集。这样，机器人和障碍物之间保持一个合理的距离，也就是说，例如前方有个门，要提前探知机器人是否能穿过这个门。</p>
<p><strong>inflation_radius：</strong>给定机器人与障碍物之间必须要保持的最小距离。按照机器人的内切半径对障碍物进行膨胀处理。</p>
<p><strong>observation_sources:</strong>设定导航包所使用的传感器。</p>
<p><strong>laser_scan_sensor和point_cloud_sensor:</strong>对传感器的坐标系和数据进行配置。这个也会用于代价地图添加和清除障碍物。例如，你可以用激光雷达传感器用于在代价地图添加障碍物，再添加kinect用于导航和清除障碍物。</p>
<p><strong>全局代价地图的配置：</strong></p>
<p>创建一个global_costmap_params.yaml文件，内容：</p>
<pre>global_costmap:
global_frame: /map
robot_base_frame: base_link
update_frequency: 5.0
static_map: true</pre>
<p><strong>global_costmap和robot_base_frame</strong>：定义机器人和地图之间的坐标变换，建立全局代价地图必须使用这个变换。</p>
<p><strong>update_frequency:</strong>地图更新的频率。</p>
<p><strong>static_map:</strong>&nbsp;是否使用一个地图或者地图服务器来初始化全局代价地图，如果不使用静态地图，这个参数为false.</p>
<p><strong>局部代价地图的配置：</strong></p>
<p>创建一个local_costmap_params.yaml 文件，内容：</p>
<p><img src="/img/fz.gif"></p>
<pre>local_costmap:
global_frame: odom
robot_base_frame: base_link
update_frequency: 5.0
publish_frequency: 2.0
static_map: false
rolling_window: true
width: 6.0
height: 6.0
resolution: 0.05</pre>
<p><img src="/img/fz.gif"></p>
<p><strong>publish_frequency:</strong>发布信息的频率，也就是costmap可视化信息发布的频率。</p>
<p><strong>rolling_window:</strong>在机器人运动过程中，代价地图始终以机器人为中心，这个在源码里是个if函数。</p>
<p><strong>width、height、resolution:</strong>代价地图的的尺寸和分辨率，单位都是m.一般情况下resolution的数值与建的static map的一致。</p>
<p><strong>基本局部规划器配置：</strong></p>
<p>创建base_local_planner_params.yaml 文件，内容：</p>
<p><img src="/img/fz.gif"></p>
<pre>TrajectoryPlannerROS:
max_vel_x: 0.45
min_vel_x: 0.1
max_vel_theta: 1.0
min_in_place_vel_theta: 0.4

acc_lim_theta: 3.2
acc_lim_x: 2.5
acc_lim_y: 2.5

holonomic_robot: false</pre>
<p><img src="/img/fz.gif"></p>
<p>这个配置文件设定了机器人的最大和最小速度限制值，也设定了加速度的限值。</p>
<p><strong>holonomic_robot:</strong>&nbsp;如果你的机器人是全向移动机器人那么此值为true，笔者的为差分型的。</p>
<p>为了运行导航功能包集，还需要创建个启动文件 move_base.launch ，内容：</p>
<p><img src="/img/fz.gif"></p>
<pre>&lt;launch&gt;
&lt;master auto="start"/&gt;

&lt;!-- Run the map server --&gt;
&lt;node name="map_server" pkg="map_server" type="map_server" args="$(find your_map_package)/your_map.pgm your_map_resolution.yaml"/&gt;

&lt;!--- Run AMCL --&gt;
&lt;include file="$(find amcl)/examples/amcl_diff.launch.launch" /&gt;
&lt;node pkg="move_base" type="move_base" respawn="false" name="move_base" output="screen"&gt;
&lt;rosparam file="$(find your_nav_package)/launch/costmap_common_params.yaml" command="load" ns="global_costmap" /&gt;
&lt;rosparam file="$(find your_nav_package)/launch/costmap_common_params.yaml" command="load" ns="local_costmap" /&gt;
&lt;rosparam file="$(find your_nav_package)/launch/local_costmap_params.yaml" command="load" /&gt;
&lt;rosparam file="$(find your_nav_package)/launch/global_costmap_params.yaml" command="load" /&gt;
&lt;rosparam file="$(find your_nav_package)/launch/base_local_planner_params.yaml" command="load" /&gt;
&lt;/node&gt;
&lt;/launch&gt;</pre>
<p><img src="/img/fz.gif"></p>
<p>利用自适应蒙特卡罗定位（AMCL）算法完成机器人定位，此方法是一种在2D环境下移动机器人的概率统计方法，这种方法在ROS系统中的具体实现是通过在已知地图的基础上使用粒子滤波算法跟踪机器人的位姿。如果你在rviz里不通过2D Pose Estimate 按钮设定初始位姿，则AMCL会假定你的机器人从坐标原点开始运行。这个包默认激光雷达数据，你也可以修改源码，适应如双目之类的传感器。amcl_diff.launch.launch是专用于支持差分驱动机器人平台的&nbsp;<a href="https://github.com/ros-planning/navigation/tree/indigo-devel/amcl" rel="external nofollow noreferrer">https://github.com/ros-planning/navigation/tree/indigo-devel/amcl</a>&nbsp;内容如下：</p>
<p><img src="/img/fz.gif"></p>
<pre>&lt;launch&gt;
&lt;node pkg="amcl" type="amcl" name="amcl" output="screen"&gt;
&lt;!-- Publish scans from best pose at a max of 10 Hz --&gt;
&lt;param name="odom_model_type" value="diff"/&gt;
&lt;param name="odom_alpha5" value="0.1"/&gt;
&lt;param name="transform_tolerance" value="0.2" /&gt;
&lt;param name="gui_publish_rate" value="10.0"/&gt;
&lt;param name="laser_max_beams" value="30"/&gt;
&lt;param name="min_particles" value="500"/&gt;
&lt;param name="max_particles" value="5000"/&gt;
&lt;param name="kld_err" value="0.05"/&gt;
&lt;param name="kld_z" value="0.99"/&gt;
&lt;param name="odom_alpha1" value="0.2"/&gt;
&lt;param name="odom_alpha2" value="0.2"/&gt;
&lt;!-- translation std dev, m --&gt;
&lt;param name="odom_alpha3" value="0.8"/&gt;
&lt;param name="odom_alpha4" value="0.2"/&gt;
&lt;param name="laser_z_hit" value="0.5"/&gt;
&lt;param name="laser_z_short" value="0.05"/&gt;
&lt;param name="laser_z_max" value="0.05"/&gt;
&lt;param name="laser_z_rand" value="0.5"/&gt;
&lt;param name="laser_sigma_hit" value="0.2"/&gt;
&lt;param name="laser_lambda_short" value="0.1"/&gt;
&lt;param name="laser_lambda_short" value="0.1"/&gt;
&lt;param name="laser_model_type" value="likelihood_field"/&gt;
&lt;!-- &lt;param name="laser_model_type" value="beam"/&gt; --&gt;
&lt;param name="laser_likelihood_max_dist" value="2.0"/&gt;
&lt;param name="update_min_d" value="0.2"/&gt;
&lt;param name="update_min_a" value="0.5"/&gt;
&lt;param name="odom_frame_id" value="odom"/&gt;
&lt;param name="resample_interval" value="1"/&gt;
&lt;param name="transform_tolerance" value="0.1"/&gt;
&lt;param name="recovery_alpha_slow" value="0.0"/&gt;
&lt;param name="recovery_alpha_fast" value="0.0"/&gt;
&lt;/node&gt;
&lt;/launch&gt;</pre>
<p><img src="/img/fz.gif"></p>
<p><strong>min_particles和max_particles：</strong>设定算法运行所允许的粒子的最小和最大数量，如果粒子数多，就算会更加精确，当然也后悔更加消耗cpu资源。</p>
<p><strong>laser_model_type：</strong>配置激光雷达类型。也可以设置beam光束雷达。</p>
<p><strong>laser_likelihood_max_dist：</strong>设置地图中障碍物膨胀的最大距离。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-28 15:43:20 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/www/" title="www&period;">www&period;</a>, <a href="https://www.biecuoliao.com/tag/%e8%bf%98%e9%9c%80/" title="还需">还需</a>, <a href="https://www.biecuoliao.com/tag/border/" title="border">border</a>, <a href="https://www.biecuoliao.com/tag/%e5%af%bc%e8%88%aa/" title="导航">导航</a>, <a href="https://www.biecuoliao.com/tag/%e5%88%9d%e5%a7%8b%e5%8c%96/" title="初始化">初始化</a>, <a href="https://www.biecuoliao.com/tag/%e5%91%8a%e8%af%89/" title="告诉">告诉</a>, <a href="https://www.biecuoliao.com/tag/recover/" title="recover">recover</a>, <a href="https://www.biecuoliao.com/tag/%e7%b2%92%e5%ad%90/" title="粒子">粒子</a>, <a href="https://www.biecuoliao.com/tag/kinect/" title="kinect">kinect</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>（转）ROS导航之参数配置和自适应蒙特卡罗定位的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3wWn1R3.html" rel="bookmark">ROS导航之参数配置和自适应蒙特卡罗定位</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				我们的机器人使用两种导航算法在地图中移动:全局导航(global)和局部导航(local).这些导航算法通过代价地图来处理地图中的各种信息,导航stack使用两种costmaps http://www.cnblogs.com/zjiaxing/p/5543386.html存储环境的障碍信息.一个costmap进行全局规划,在整个环境做长期的规划,而另一个是用于局部规划和避障. 全局导航: 在已建立的地图上做一个远距离目标的路径规划. 局部导航: 在正在建立的地图上做近距离目标同时要实时避开障碍物			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0Rd7d74.html" rel="bookmark">ROS 进阶学习笔记（16）：ROS导航1：关于Costmap&lowbar;2d Package （代价地图包）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				=== 关于Costmap_2d Package === wiki page: http://wiki.ros.org/costmap_2d === 我遇到的问题是 obstacle layer的刷新频率太低 === costmap_2d包下的所有类文档:http://docs.ros.org/hydro/api/costmap_2d/html/annotated.html 其中,值得注意滴是 costmap_2d::ObservationBuffer 这个类,这个类会被 costmap_2d:			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3rOePw4.html" rel="bookmark">Ubuntu虚拟机&plus;ROS&plus;Android开发环境配置笔记</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Ubuntu虚拟机+ROS+Android开发环境配置笔记 虚拟机设置: 1.本地环境:Windows 7:VMWare:联网 2.虚拟环境 :Ubuntu 14.04, 比较稳定,且支持很多ROS 3.虚拟机配置:硬盘至少50G,因为整个工具链配置起来需要很多空间,性能方面可以尽量往高配置. 4.虚拟环境搭建起来后,Ubuntu会弹出提示窗口询问是否升级软件,升级完后重启,约30分钟,取决于网络环境. 5.重启后,terminal执行以下: $ sudo apt-get upgrade $ s			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MBlkJK3.html" rel="bookmark">JVM性能优化--JVM参数配置，使用JMeter简单测试配合说明参数调优</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.JVM参数配置 1.常见参数配置 -XX:+PrintGC 每次触发GC的时候打印相关日志 -XX:+UseSerialGC 串行回收 -XX:+PrintGCDetails 更详细的GC日志 -Xms 堆初始值 -Xmx 堆最大可用值 -Xmn 新生代堆最大可用值 -XX:SurvivorRatio 用来设置新生代中eden空间和from/to空间的比例. -XX:NewRatio 配置新生代与老年代占比 1:2 含以-XX:SurvivorRatio=eden/from=den/to 总			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0nrkVp0.html" rel="bookmark">理解ROS导航软件包集</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ROS导航软件包的主要目的是将机器人从初始位置移动到目标位置,在移动的过程中不会与周围环境发生任何碰撞. ROS导航软件包附带了几种导航相关的算法实现,它们可以帮助我们轻松实现移动机器人的自主导航. 用户只需要提供机器人的目标位置和来自轮子编码器.IMU.GPS等传感器获得的测量数据,激光扫描器的数据流, 以及其他传感器的数据流,例如激光雷达数据或者来自Kinect等传感器的3D点云数据,导航软件包的输出是控制移动的 速度命令,这些命令将控制机器人移动到目标位置.导航软件包集包含了一些标准算法的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/B0R9nRM.html" rel="bookmark">线上机器JVM参数配置</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				记录一下线上机器的JVM参数配置: CATALINA_OPTS=&quot;$CATALINA_OPTS -server -Djava.awt.headless=true -Xms2560m [JVM初始分配的堆内存 2.5G]-Xmx2560m [JVM最大可用堆内存 2.5G]-Xss256k [每个线程的堆栈大小]-XX:PermSize=128m [永久代大小]-XX:MaxPermSize=384m [永久代最大值]-XX:NewSize=1024m [新生代初始内存大小]-XX:MaxNewS			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4NJAqw4.html" rel="bookmark">YARN日志聚合相关参数配置</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				日志聚合是YARN提供的日志中央化管理功能,它能将运行完成的Container/任务日志上传到HDFS上,从而减轻NodeManager负载,且提供一个中央化存储和分析机制.默认情况下,Container/任务日志存在在各个NodeManager上,如果启用日志聚合功能需要额外的配置. 参数配置yarn-site.xml 1.yarn.log-aggregation-enable 参数说明:是否启用日志聚合功能,日志聚合开启后保存到HDFS上. 默认值:false 2.yarn.log-aggr			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3q5Lmp3.html" rel="bookmark">nginx一些参数配置详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				nginx的配置:    正常运行的必备配置:       1.user username [groupname];           指定运行worker进程的用户和组       2.pid /path/to/pidfile_name nginx的pid文件 3.worker_rlimit_nofile #;            一个worker进程所能够打开的最大文件句柄数:       4.worker_rlimit_sigpending #;            设定每个用户能够			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xQEj73.html" rel="bookmark">教你如何利用分布式的思想处理集群的参数配置信息&mdash;&mdash;spring的configurer妙用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				引言 最近LZ的技术博文数量直线下降,实在是非常抱歉,之前LZ曾信誓旦旦的说一定要把&lt;深入理解计算机系统&gt;写完,现在看来,LZ似乎是在打自己脸了.尽管LZ内心一直没放弃,但从现状来看,需要等LZ的PM做的比较稳定,时间慢慢空闲出来的时候才有机会看了.短时间内,还是要以解决实际问题为主,而不是增加自己其它方面的实力. 因此,本着解决实际问题的目的,LZ就研究出一种解决当下问题的方案,可能文章的标题看起来挺牛B的,其实LZ就是简单的利用了一下分布式的思想,以及spring框架的特性,解决了当下的参			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/yMXygw0.html" rel="bookmark" class="title">设计模式：  单列设计模式 、模块方法设计模式</a>
					<div>
						一.单列设计模式 1.设计模式:解决某一类问题的最行之有效的方法. 2.Java中有23中基本设计模式. 3.单列设计模式:一个类在内存中只有一个对象. 为了达到单列设计模式,如下考虑: 1. 为了避 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4125GPM.html" rel="bookmark" class="title">SQL Server -&amp;gt&semi;&amp;gt&semi; 数据一致性检查命令 -- DBCC CHECKDB</a>
					<div>
						Comming soon!!! 参考文献: CHECKDB From Every Angle: Complete description of all CHECKDB stages					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dgVL7M.html" rel="bookmark" class="title">关于c语言学习    谭浩强的书</a>
					<div>
						2007-11-16 13:22:58|  分类: PROGRAMME |  标签: |举报 |字号大中小 订阅 广大有志于从事IT行业的同志们,在你们进入这一行之前千万请看这篇文章!太经典了!对你绝 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWyJzr3.html" rel="bookmark" class="title">linux开机自检配置文件fstab变只读无法修改问题</a>
					<div>
						控制linux开机自检的配置文件是/etc/fstab,在最近用的服务器中,发现fstab变成了只读权限,无法修改. 解决方法:RH5下,因磁盘改变,而导致系统停在Ctrl+d,此时需输入密码进入修改 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mzaxqd4.html" rel="bookmark" class="title">破解EBS R12应用和数据库用户密码</a>
					<div>
						1,如果你有某个EBS环境APPS用户密码,可以破解应用用户的密码 参考:Oracle EBS R12下如何破解用户密码 2,如果没有APPS用户密码,还想破解该环境A密码.要看&quot;运气&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3r261v3.html" rel="bookmark" class="title">Storm系列&lpar;十&rpar;聚流示例</a>
					<div>
						功能:将多个数据源的数据汇集到一个处理单元进行集中分类处理: 入口类TestMain 1  public class TestMain { 2    3      public static void ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MV8En23.html" rel="bookmark" class="title">JSP学习笔记（六）：自定义标签-JSP2&period;x</a>
					<div>
						一.SimpleTag 接口 和 SimpleTagSupport 类 SimpleTag 接口只有一个 doTag()方法,同时支持参数与标签体.一般实现 SimpleTagSupport 类即可. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmOxVQ3.html" rel="bookmark" class="title">Filter不过滤CSS和JS</a>
					<div>
						Filter是Java Web中用于禁止浏览器在未登录的情况下访问内部网址. 用法就不说了,看了下网上的用法基本都是贴的李刚的那本J2EE书上的代码. 需要注意的是,如果你直接设置  &lt;url- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGpaPa0.html" rel="bookmark" class="title">陀螺仪原理--网上转载</a>
					<div>
						本帖翻译自IMU(加速度计和陀螺仪设备)在嵌入式应用中使用的指南. 这篇文章主要介绍加速度计和陀螺仪的数学模型和基本算法,以及如何融合这两者,侧重算法.思想的讨论 介绍 本指南旨在向兴趣者介绍惯性ME ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzLEAy3.html" rel="bookmark" class="title">为什么要学习Numerical Analysis</a>
					<div>
						前几日我发了一个帖子,预告自己要研究一下  Numerical Analysis 非常多人问我为啥,我统一回答为AI-----人工智能 我在和教授聊天的时候,忽然到了语言发展上 我说:老S啊(和我关系 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41zlrkM.html" rel="bookmark" class="title">Chromium网页Layer Tree创建过程分析</a>
					<div>
						在Chromium中,WebKit会创建一个Graphics Layer Tree描述网页.Graphics Layer Tree是和网页渲染相关的一个Tree.网页渲染最终由Chromium的CC模 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Qjpx2M.html" rel="bookmark" class="title">译文链接：http&colon;&sol;&sol;www&period;codeceo&period;com&sol;article&sol;10-truth-programmer-must-know&period;html</a>
					<div>
						大多数时候,写代码都是挺有意义的一件事,不光能增加经验值,解决难题的时候还特别爽.耐心.毅力.执着,再加上正确的工具——只要有它们的亲密协作,优雅.漂亮的代码就是手到擒来的事儿. 但是,紧接着拙劣的资 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXllowM.html" rel="bookmark" class="title">截获导航控制器系统返回按钮的点击pop及右滑pop事件</a>
					<div>
						前几天看了@栾小布的一篇文章:Custom backBarButtonItem,在跟着做的时候我又顺便扩展了一些,写此文章的目的是为了总结一下自己所写的东西,方便以后翻看容易,同时也是自己入行iOS一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xBB6N4.html" rel="bookmark" class="title">Name Disambiguation in Author Citations using a Kway Spectral Clustering Method 论文之摘要</a>
					<div>
						研究背景 要解决的问题 名字歧义问题会带来文献检索.网络搜索以及数据库整合上带来效率问题还可能对作者带来名誉上的问题.解决的两种名字歧义问题:1.一个作者实体却有多个相似(被简写)的或者被误拼的名字. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NyNGJ3.html" rel="bookmark" class="title">Scala - 正则表达式匹配例子</a>
					<div>
						壹Try胜仟言 别忘了 import scala.util.matching._ scala&gt; var s = &quot;a_b_c_d_e&quot;s: String = a_b_c_d_ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MooxwwM.html" rel="bookmark" class="title">linux 下 xampp配置</a>
					<div>
						etc/hosts 修改 httpd.conf 修改根目录 #Include etc/extra/http-vhosts.conf 去掉#号 httpd-vhosts.conf 配置 站点名 重启服务 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xex1N3.html" rel="bookmark" class="title">人月神话--摘点</a>
					<div>
						核心:概念的完整性 1.缺乏合理的时间进度是造成项目滞后的最主要原因,他比其他的所有因素的综总和影响都大 2.关于进度安排,作者的建议:1/3计划.1/6 编码.1/4构件测试以及1/4系统测试 3. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e9omv0.html" rel="bookmark" class="title">python下django框架项目生成的文件解释</a>
					<div>
						目录MyDjangoProject下表示工程的全局配置,分别为setttings.py.urls.py和wsgi.py,1.其中setttings.py包括了系统的数据库配置.应用配置和其他配置,2. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l1EnE3.html" rel="bookmark" class="title">ubuntu 16&period;04下安装oracle jdk 1&period;7</a>
					<div>
						网上搜索了下,知道了大概,不能用apt装了,oracle也不再提供deb包了.只能下tar.gz包自己装. 先下载下来jdk:http://www.oracle.com/technetwork/jav ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JOALQM.html" rel="bookmark" class="title">N-Queens leetcode java</a>
					<div>
						题目: The n-queens puzzle is the problem of placing n queens on an n×n chessboard such that no two que ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.027 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
